package rt.lanyo.game.ddz;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import rt.lanyo.game.ddz.adapter.MyAdapter;
import rt.lanyo.game.ddz.mgr.PlayerMgr;
import rt.lanyo.game.ddz.mgr.TaskMgr;
import rt.lanyo.game.ddz.model.Card;
import rt.lanyo.game.ddz.model.Player;
import rt.lanyo.game.ddz.service.MusicService;
import rt.lanyo.game.ddz.util.G;
import rt.lanyo.game.ddz.widget.MyDialog;
import android.app.Dialog;
import android.content.Intent;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Gallery;
import android.widget.ImageButton;
import android.widget.ImageSwitcher;
import android.widget.ImageView;
import android.widget.RadioButton;
import android.widget.TextView;
import android.widget.ViewSwitcher.ViewFactory;

public class Info extends Base implements AdapterView.OnItemSelectedListener{
	public static final byte DIALOG_DELETE = 1;
	public static final byte DIALOG_TASK = 2;
	public static final byte DIALOG_CHANGE_HEAD = 3;
	
	public static int[] images = {
		R.drawable.image1, R.drawable.image2, R.drawable.image3, R.drawable.image4, R.drawable.image5, 
		R.drawable.image6, R.drawable.image7, R.drawable.image8, R.drawable.image9, R.drawable.image10};
	
	private RadioButton male;
	private RadioButton female;
	private static Button sure;
	private Button delete;
	private Button normal;
	private Button fun;
	private Button task;
	private ImageButton head;
	private static EditText nickEt;
	private static TextView nameTv;
	
	private Gallery gallery;
	private ImageSwitcher switcher;
	private MyAdapter adapter;
	private int imgPosition;
	private MyDialog changeHeadDialog;
	private Player player;
	private MyDialog deleteDialog;
	private boolean modifyHead;  //看是否修改了头像
	private MyDialog taskDialog;
	
	private TextView score;
	private TextView title;
	
	protected void create() {
		setContentView(R.layout.info);
		initWidgets();
		initPlayer();
	}
	
	private void initWidgets() {
		male = (RadioButton) findViewById(R.id.male);
		female = (RadioButton) findViewById(R.id.female);
		sure = (Button) findViewById(R.id.sure);
		delete = (Button) findViewById(R.id.delete);
		normal = (Button) findViewById(R.id.normal_mode);
		fun = (Button) findViewById(R.id.fun_mode);
		task = (Button) findViewById(R.id.task_mode);
		head = (ImageButton) findViewById(R.id.head);
		nickEt = (EditText) findViewById(R.id.nick);
		nameTv = (TextView) findViewById(R.id.nick_tv);
		score = (TextView) findViewById(R.id.score);
		title = (TextView) findViewById(R.id.title);
		head.setOnClickListener(this);
	}
	
	private void initPlayer() {
		player = PlayerMgr.find();
		if(player!=null) { //如果已经有用户信息
			nickEt.setText(player.name); //设置姓名
			if(player.sex==null||player.sex==0) { //设置性别
				male.setChecked(true);
			} else {
				female.setChecked(true);
			}
			head.setImageResource(exist(player.iconIndex));  //设置头像
			score.setText(player.score==null?"0":player.score.toString());//设置积分
			title.setText(player.title==null?PlayerMgr.findTitle(0):player.title);//设置等级
			
			setWidgetsStatus(false);
		} else {
			setWidgetsStatus(true);
			score.setText(null);//设置积分
			title.setText(null);//设置等级
		}
	}
	
	public void onClick(View v) {
		super.onClick(v);
		if(v==normal || v==MyDialog.getBtn(taskDialog, R.string.enter_normal)) { //"普通模式" 或者 "闯关模式" -->> "刷怪升级"
			MyDialog.dismiss(taskDialog);
			Intent intent = new Intent(Info.this, Game.class);
			G.gameMode = G.GAME_MODE_NORMAL;//普通模式
			startActivity(intent);
			System.gc();
		} else if(v==fun) {//"娱乐模式"
			Intent intent = new Intent(Info.this, Game.class);
			G.gameMode = G.GAME_MODE_FUN;//娱乐模式
			startActivity(intent);
			System.gc();
		} else if(v==task) { //"闯关模式"
			if(player==null) player = PlayerMgr.find(); 
			if(player.score==null || player.score<50) { //积分不够
				showDialog(DIALOG_TASK);
			} else { //进入闯关内容介绍
				TaskMgr.out = false;
				Intent intent = new Intent(Info.this, Tasks.class);
				startActivity(intent);
				System.gc();
			}
		} else if(v==MyDialog.getBtn(taskDialog, R.string.cancel)) {//"闯关模式" -->> "取消"
			MyDialog.dismiss(taskDialog);
		} else if(v==delete) { //"删除"
			if(player!=null) {
				showDialog(DIALOG_DELETE);
			}
		} else if(v==sure) { //"确定" "修改"
			if(nickEt.getVisibility()==EditText.VISIBLE) {
				if(player!=null) {
					if(modifyHead) { //如果用户修改了头像，没有修改就用原来自己的头像
						player.iconIndex = images[imgPosition];
						modifyHead = false;
					}
					player.name = nickEt.getText().toString();
					player.sex = male.isChecked()?0:1;
					PlayerMgr.saveOrUpdate(player);
				}
				if(player==null) { //第一次添加player 或者 用户被删过之后(所以删除用户后要将player清空)
					if(!validateNick()) return;
					
					player = new Player();
					player.iconIndex = images[imgPosition];
					player.name = nickEt.getText().toString();
					
					
					player.score = Player.INIT_SCORE;
					
					player.sex = male.isChecked()?0:1;
					player.id = PlayerMgr.saveOrUpdate(player);
					score.setText(String.valueOf(Player.INIT_SCORE));//设置积分
					title.setText(PlayerMgr.findTitle(Player.INIT_SCORE));//设置等级
				}
				setWidgetsStatus(false);
			} else {
				setWidgetsStatus(true);
			}
		} else if(v==head) { //"更改头像"
			showDialog(DIALOG_CHANGE_HEAD);
		} else if(v==MyDialog.getBtn(changeHeadDialog, R.string.sure)) { //"更改头像" -->> "确定"
			modifyHead = true;
			head.setImageResource(images[imgPosition]);
			MyDialog.dismiss(changeHeadDialog);
		}  else if(v==MyDialog.getBtn(changeHeadDialog, R.string.cancel)) {//"更改头像" -->> "取消"
			MyDialog.dismiss(changeHeadDialog);
		} else if(v==MyDialog.getBtn(deleteDialog, R.string.yes)) {//"删除" -->> "是"
			score.setText(null);//设置积分
			title.setText(null);//设置等级
			
			PlayerMgr.delete();
			head.setImageResource(images[0]);
			nickEt.setText(null);
			player = null; //清空player
			setWidgetsStatus(true);
			
			/*******这句代码是暂时的******/
			setBtnEnable(sure, true);
			MyDialog.dismiss(deleteDialog);
		}  else if(v==MyDialog.getBtn(deleteDialog, R.string.no)) {//"更改头像" -->> "否"
			MyDialog.dismiss(deleteDialog);
		} 
		
	}
	
	private boolean validateNick() {
		String nick = nickEt.getText().toString();
		if(nick == null || "".equals(nick) ) {
			G.toast(R.string.no_nick);
			return false;
		} 
		if(nick.indexOf(" ") != -1) {
			G.toast(R.string.nick_error);
			return false;
		}
		return true;
	}
	
	public void onItemSelected(AdapterView<?> parent, View view,
			int position, long id) {
		imgPosition = position;
		switcher.setImageResource(images[imgPosition]);
	}
	public void onNothingSelected(AdapterView<?> arg0) {}
	
	private void setBtnEnable(Button btn, boolean able) {
		btn.setEnabled(able);
		if(able) {
			btn.setTextColor(getResources().getColorStateList(R.color.btn_text));
		} else {
			btn.setTextColor(getResources().getColor(R.color.btn_d));
		}
	}
	
	private void setWidgetsStatus(boolean modifying) {
		if(modifying) {  //说明没有用户,需要重新创建用户  或者要修改
			setBtnEnable(normal, false);
			setBtnEnable(fun, false);
			setBtnEnable(task, false);
			head.setClickable(true);
			nickEt.setVisibility(EditText.VISIBLE);
			nameTv.setVisibility(TextView.GONE);
			sure.setText("确定");
			setBtnEnable(delete, false);
			male.setClickable(true);
			female.setClickable(true);
			if(player!=null && player.sex == Player.FEMALE) {
				female.setChecked(true);
			} else {
				male.setChecked(true);
			}
		} else { //说明有用户
			modifyHead = false;
			setBtnEnable(normal, true);
			setBtnEnable(task, true);
			setBtnEnable(fun, true);
			head.setClickable(false);
			nickEt.setVisibility(EditText.GONE);
			nameTv.setVisibility(TextView.VISIBLE);
			nameTv.setText(nickEt.getText());
			sure.setText("修改");
			setBtnEnable(delete, true);
			male.setClickable(false);
			female.setClickable(false);
		}
	}
	
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if(keyCode==KeyEvent.KEYCODE_BACK) {
			MusicService.playSound(Card.CLICK);
		}
		return super.onKeyDown(keyCode, event);
	}
	
	protected void onResume() {
		super.onResume();
		if(G.status!=G.STATUS_LOGIN && G.status != G.STATUS_INFO) {//如果从游戏界面出来， 就要重新加载Player信息
			player = (Player)PlayerMgr.find();
			
			score.setText(player.score==null?"0":player.score.toString());
			title.setText(player.title==null?"包身工":player.title);
		}
		
		G.status = G.STATUS_INFO;
		G.startMusicService(MusicService.CMD_GO_ON);
		G.startMusicService(MusicService.TYPE_WELCOME, MusicService.CMD_PLAY);
	}

	protected void onStop() {
		super.onStop();
		if(G.status == G.STATUS_INFO) G.startMusicService(MusicService.CMD_PAUSE);
	}
	
	protected Dialog onCreateDialog(int id) {
		switch(id) {
		case DIALOG_CHANGE_HEAD:
			if(changeHeadDialog==null) {
				List<Map<Object, Object>> data = new ArrayList<Map<Object,Object>>();
				for(int i : images) {
					Map<Object, Object> map = new HashMap<Object, Object>();
					map.put("id", i);
					data.add(map);
				}
				adapter = new MyAdapter(this, data, R.layout.head_item, new String[]{"id"}, new int[]{R.id.head}, null);
				View view = LayoutInflater.from(this).inflate(R.layout.gallery, null);
		    	gallery = (Gallery) view.findViewById(R.id.gallery);
		    	gallery.setAdapter(adapter); 
		    	gallery.setSelection(images.length/2);
		    	gallery.setOnItemSelectedListener(this);
		    	switcher = (ImageSwitcher) view.findViewById(R.id.switcher);
		    	switcher.setFactory(new ViewFactory() {
					public View makeView() {
						ImageView view = new ImageView(Info.this);
						view.setLayoutParams(new ImageSwitcher.LayoutParams(60, 60));
						return view;
					}
				});
				changeHeadDialog = MyDialog.create(R.string.choose_head, view, R.string.sure, R.string.cancel);
			}
			return changeHeadDialog.dialog;
		case DIALOG_DELETE:
			if(deleteDialog==null) {
				deleteDialog = MyDialog.create(R.string.tip, R.string.delete_ask, R.string.yes, R.string.no);
			}
			return deleteDialog.dialog;
		case DIALOG_TASK:
			if(taskDialog==null) {
				taskDialog = MyDialog.create(R.string.tip, R.string.score_not_enough, R.string.enter_normal, R.string.cancel);
			}
			return taskDialog.dialog;
		}
		return super.onCreateDialog(id);
	}
	
	public static int exist(int id) {
		for(int i : images) {
			if(i==id) return id;
		}
		return images[0];
	}
}
