package rt.lanyo.game.ddz;
import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import com.google.gson.reflect.TypeToken;

import rt.lanyo.game.ddz.adapter.MyAdapter;
import rt.lanyo.game.ddz.adapter.MyAdapter.ViewCallback;
import rt.lanyo.game.ddz.mgr.ImgMgr;
import rt.lanyo.game.ddz.mgr.OnlineMgr;
import rt.lanyo.game.ddz.mgr.PlayerMgr;
import rt.lanyo.game.ddz.mgr.SaveMgr;
import rt.lanyo.game.ddz.model.Card;
import rt.lanyo.game.ddz.model.Player;
import rt.lanyo.game.ddz.service.MusicService;
import rt.lanyo.game.ddz.util.G;
import rt.lanyo.game.ddz.util.J;
import rt.lanyo.game.ddz.util.S;
import rt.lanyo.game.ddz.vo.CmdVO;
import rt.lanyo.game.ddz.widget.MyDialog;
import android.app.Activity;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Message;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.AutoCompleteTextView;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.TextView;
import android.widget.AdapterView.OnItemClickListener;

public class Login extends Base implements OnItemClickListener,ViewCallback{
	public static final byte DIALOG_LOGIN_FAILE = 3;
	public static final byte DIALOG_LOGIN_SUCCESS = 4;
	public static final byte DIALOG_DELETE_ACCOUNT = 5;
	public static final byte DIALOG_DEL_CONFIRM = 6;
	public static final byte DIALOG_RANK_SUCCESS = 7;
	public static final byte DIALOG_RANK_FAILED = 8;
	private Button singleGame;
	private Button register;
	private Button tour;
	private Button loginBtn;
	private Button delAccount; //删除账号信息
	private Button convert;  // 反选
	private Button cancelDel; //取消删除
	public List<String> selectedAccounts = new ArrayList<String>();
	private List<Map<Object, Object>> data;
	private ListView listView;
	private static MyDialog loginDialog;
	private MyDialog exitDialog;
	private MyDialog delAccountDialog;
	private MyDialog delConfirmDialog;
	private MyAdapter adapter;
	private CheckBox autoLogin;
	private CheckBox rememberPwd;
	private AutoCompleteTextView accountET;
	private EditText pwdET;
	private ImageButton moreAccount;
	
	public static String acc;
	public static String pwd;
	public static boolean isRemberPwd;
	
	private List<Player> vos;
	private Player lastVO;
	private byte lastStatus;
	
	//登陆用的线程
	private Thread loginThread;
	private Button rank;
	private MyDialog rankDialog;
	private Type rankType = new TypeToken<List<Player>>(){}.getType();  
	private Type loginType = new TypeToken<Map<String, String>>(){}.getType();
	private List<Player> rankPlayers;
	
	private Button help;
	private Button moreGame;
	
	protected void create() {
		setContentView(R.layout.login);
		
		Activity welcome = G.activityMap.get(Welcome.class);
		if(welcome!=null) welcome.finish(); //销毁Welcome
		
		initSounds();
		initWidgets();
	}
	
	protected void handle(Message msg) {
		super.handle(msg);
		switch(msg.what) {
		case DIALOG_LOGIN_SUCCESS:
			Player vo = new Player(accountET.getText().toString(), pwdET.getText().toString(), rememberPwd.isChecked(), autoLogin.isChecked());
			vo.lastLoginTime = System.currentTimeMillis();
			PlayerMgr.saveLoginPlayer(vo);
			MyDialog.dismiss(loginDialog);
			break;
		case DIALOG_LOGIN_FAILE:
			if(!MyDialog.exist(loginDialog)) return;
			MyDialog.change(loginDialog, R.string.tip, R.string.account_pwd_error, R.string.close);
			break;
		case DIALOG_NET_ERROR:
			OnlineMgr.close(); //关掉连接
			if(!MyDialog.exist(loginDialog)) return;
			MyDialog.change(loginDialog, R.string.tip, R.string.login_faile, R.string.sure);
			break;
		case DIALOG_RANK_SUCCESS:
			if(!MyDialog.exist(rankDialog)) return;
			List<Map<String, Object>> data = new ArrayList<Map<String,Object>>();
			for(Player p : rankPlayers) {
				data.add(getMap(p));
			}
			View v = LayoutInflater.from(Login.this).inflate(R.layout.rank, null);
			ListView lv = (ListView) v.findViewById(R.id.rank);
			lv.setAdapter(new SimpleAdapter(Login.this, data, R.layout.rank_item, 
					new String[]{Player.NAME,Player.SCORE,Player.TITLE}, 
					new int[]{R.id.nick, R.id.score, R.id.title}));
			MyDialog.change(rankDialog, R.string.rank, v, R.string.close);
			break;
		case DIALOG_RANK_FAILED:
			if(!MyDialog.exist(rankDialog)) return;
			MyDialog.change(rankDialog, R.string.rank, R.string.loading_failed, R.string.close);
			break;
		}
	}
	
	protected void deal(boolean success, CmdVO c) {
		if(CmdVO.LOGIN.equals(c.cmd)) {
			killThread(loginThread);
			if(!MyDialog.exist(loginDialog)) return;
			if(!success) {//网络没连接
				sendMsg(DIALOG_NET_ERROR);
			} else { //网络连接正常
				Map<String, String> loginInfo = J.fromJson(c.content, loginType);
				Player vo = null;
				if(loginInfo!=null) vo = J.fromJson(loginInfo.get(CmdVO.LOGIN), Player.class);
				if(vo!=null) {
					G.me = vo;
					G.me.name = S.get(vo.name);
					G.me.iconIndex = S.get(vo.iconIndex);
					G.me.score = S.get(vo.score);
					sendMsg(DIALOG_LOGIN_SUCCESS);
					Intent intent = new Intent(getApplicationContext(),Room.class);
					intent.putExtra(CmdVO.LIST, loginInfo.get(CmdVO.LIST));
					startActivity(intent);
				} else {//登陆失败
					sendMsg(DIALOG_LOGIN_FAILE);
				}
			}
		} else if(CmdVO.RANK.equals(c.cmd)){
			if(!MyDialog.exist(rankDialog)) return;
			rankPlayers = J.fromJson(c.content, rankType);
			sendMsg(rankPlayers!=null?DIALOG_RANK_SUCCESS:DIALOG_RANK_FAILED);
		}
	}

	private void initWidgets() {
		singleGame = (Button) findViewById(R.id.single);
		register = (Button) findViewById(R.id.register);
		moreGame = (Button) findViewById(R.id.more_game);
		help = (Button) findViewById(R.id.help);
		tour = (Button) findViewById(R.id.tour);
		loginBtn = (Button) findViewById(R.id.login);
		autoLogin = (CheckBox) findViewById(R.id.auto_login);
		rememberPwd = (CheckBox) findViewById(R.id.remember_pwd);
		pwdET = (EditText)findViewById(R.id.pwd);
		accountET = (AutoCompleteTextView)findViewById(R.id.account);
		accountET.setTypeface(G.normalType);
		moreAccount = (ImageButton) findViewById(R.id.more_account);
		rank = (Button) findViewById(R.id.rank);
		rank.setOnClickListener(this);
		singleGame.setOnClickListener(this);
		moreGame.setOnClickListener(this);
		help.setOnClickListener(this);
		
		accountET.setOnItemClickListener(this);
		autoLogin.setOnCheckedChangeListener(this);
		rememberPwd.setOnCheckedChangeListener(this);
		moreAccount.setOnClickListener(this);
	}
	
	public void resetPanel(){
		pwdET.setText(null);
		accountET.setText(null);
		autoLogin.setChecked(false);
		rememberPwd.setChecked(false);
	}

	public void initSounds() {
		SaveMgr mgr = new SaveMgr(this);
		MusicService.initSounds(this);
		MusicService.needMusic = mgr.get(SaveMgr.MUSIC, true);
		MusicService.needSound = mgr.get(SaveMgr.SOUND, true);
		MusicService.needVibrate = mgr.get(SaveMgr.VIBRATE, true);
		ImgMgr.needAnim = mgr.get(SaveMgr.ANIM, true);
	}

	public void onClick(View v) {
		super.onClick(v);
		if (v == singleGame) {
			Intent intent = null;
			G.netMode = false;
			intent = new Intent(this, Info.class);
			startActivity(intent);
		} else if (v == MyDialog.getBtn(exitDialog, R.string.yes)) {
			MyDialog.dismiss(exitDialog);
			for (Entry<Object, Activity> e : G.activityMap.entrySet()) {
				Activity a = e.getValue();
				if (a != null && e.getKey()!=Login.class) a.finish();
			}
			G.exit();
			OnlineMgr.close();
			finish();
			System.exit(0);
		} else if (v == MyDialog.getBtn(exitDialog, R.string.no)) {
			MyDialog.dismiss(exitDialog);
		} else if(v==register) {
			Intent intent = null;
			G.netMode = false;
			intent = new Intent(this, Register.class);
			startActivity(intent);
		} else if(v==loginBtn) {
			Player vo = PlayerMgr.validateLogin(accountET.getText().toString(), pwdET.getText().toString());
			if(vo!=null) login(vo);
		} else if(v==MyDialog.getBtn(loginDialog, R.string.cancel) || v==MyDialog.getBtn(loginDialog, R.string.sure) || v==MyDialog.getBtn(loginDialog, R.string.close)) {
			MyDialog.dismiss(loginDialog);
			if(v!=MyDialog.getBtn(loginDialog, R.string.close)) OnlineMgr.close();
		} else if(v==moreAccount) {
			vos = PlayerMgr.getLoginPlayers();
			if(vos==null) return;
			List<String> accounts = new ArrayList<String>();
			for(Player vo : vos) {
				accounts.add(vo.account);
			}
			accountET.setAdapter(new ArrayAdapter<String>(this, R.layout.login_item, accounts));
			accountET.showDropDown();
		} else if(v==delAccount) {
			if(selectedAccounts.isEmpty()) {
				G.toast(R.string.no_selected);
				return;
			}
			showDialog(DIALOG_DEL_CONFIRM);
		} else if(v==MyDialog.getBtn(delConfirmDialog,R.string.yes )) {
			if(selectedAccounts.contains(accountET.getText().toString())) resetPanel();
			PlayerMgr.delLoginPlayer(selectedAccounts);
			selectedAccounts.clear(); //清空要删除的帐号
			MyDialog.dismiss(delConfirmDialog);
			openDelAccountsDialog(PlayerMgr.getLoginPlayers());
			G.toast(R.string.del_success);//提示删除成功!
		} else if(v==MyDialog.getBtn(delConfirmDialog,R.string.no )) {
			MyDialog.dismiss(delConfirmDialog);
		} else if(v==cancelDel) {
			MyDialog.dismiss(delAccountDialog);
		} else if(v==convert) {
			for(Map<Object, Object> a : data) {
				String account = a.get(Player.ACCOUNT).toString();
				if(selectedAccounts.contains(account)) {
					selectedAccounts.remove(account);
				} else {
					selectedAccounts.add(account);
				}
			}
			adapter.notifyDataSetChanged();//让ListView再次调用getView
		} else if(v==tour) { //游客登录
			login(null);
		} else if(v==rank) {
			new Thread(new Runnable() {
				public void run() {
					OnlineMgr.sendCmd(CmdVO.RANK, Login.this);
				}
			}).start();
			openRank();
		} else if(v==MyDialog.getBtn(rankDialog, R.string.close)) {
			MyDialog.dismiss(rankDialog);
		} else if(v==help) {
			Intent intent = new Intent(this, Help.class);
			startActivity(intent);
		} else if(v==moreGame) {
			G.toast(R.string.hope);
		}
	}

	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if (keyCode == KeyEvent.KEYCODE_BACK) {
			MusicService.playSound(Card.CLICK);
			showDialog(DIALOG_EXIT);
		}
		return super.onKeyDown(keyCode, event);
	}
	
	protected Dialog onCreateDialog(int id) {
		switch(id) {
		case DIALOG_EXIT:
			if (exitDialog == null) {
				exitDialog = MyDialog.create(R.string.tip, R.string.exit_ask, R.string.yes, R.string.no);
			}
			return exitDialog.dialog;
		case DIALOG_DEL_CONFIRM:
			if (delConfirmDialog == null) {
				delConfirmDialog = MyDialog.create(R.string.tip, R.string.del_ask, R.string.yes, R.string.no);
			}
			return delConfirmDialog.dialog;
		}
		
		return super.onCreateDialog(id);
	}

	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.login, menu);
		return super.onCreateOptionsMenu(menu);
	}
	
	public boolean onOptionsItemSelected(MenuItem item) {
		super.onOptionsItemSelected(item);
		
		int id = item.getItemId();
		switch(id) { 
		case R.id.menu_delete:
			List<Player> playerList = PlayerMgr.getLoginPlayers();
			if(playerList==null||playerList.isEmpty()) {
				G.toast(R.string.no_del_accounts);
				return true;
			}
			openDelAccountsDialog(playerList);
			break;
		}
		return true;
	}

	protected void onResume() {
		super.onResume();
		lastStatus = G.status;
		
		if(G.status != G.STATUS_LOGIN) { //如果不是按home键后再进入登陆界面,就更新登陆框信息
			lastVO = PlayerMgr.getLastLoginPlayer();
			initLoginInfo(lastVO, false);
		}
		
		if(lastStatus==G.STATUS_WELCOME && autoLogin.isChecked()) {
			Player vo = PlayerMgr.validateLogin(lastVO.account, lastVO.pwd);
			if(vo!=null) login(vo); //自动登陆
		}
		
		G.status = G.STATUS_LOGIN;
		G.startMusicService(MusicService.CMD_GO_ON);
		G.startMusicService(MusicService.TYPE_WELCOME, MusicService.CMD_PLAY);
		
		if(acc!=null && pwd!=null && !"".equals(acc) && !"".equals(pwd)) {
			accountET.setText(acc);
			pwdET.setText(pwd);
			rememberPwd.setChecked(isRemberPwd);
			autoLogin.setChecked(false);
			Player vo = PlayerMgr.validateLogin(acc, pwd);
			if(vo!=null) login(new Player(acc, pwd));
			acc = null;
			pwd = null;
			isRemberPwd = false;
		}
	}

	protected void onStop() {
		super.onStop();
		if(G.status == G.STATUS_LOGIN) G.startMusicService(MusicService.CMD_PAUSE);
	}

	public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
		super.onCheckedChanged(buttonView, isChecked);
		if(buttonView == autoLogin){
			if(isChecked) { //如果选中了自动登陆，就顺便选上记住密码
				rememberPwd.setChecked(true);
			}
		} else if(buttonView == rememberPwd){
			if(!isChecked) {//如果去除了记住密码，就顺便去处自动登陆
				autoLogin.setChecked(false);
			}
		} else {
			View view = ((View)buttonView.getParent().getParent()).findViewById(R.id.account);
			if(view instanceof TextView) {
				TextView t = (TextView)view;
				if(buttonView.isChecked()){
					String text = t.getText().toString();
					if(!selectedAccounts.contains(text)) selectedAccounts.add(text);
				} else {
					selectedAccounts.remove(t.getText().toString());
				}
			}
		}
	}

	public void login(final Player vo){
		View view = getLayoutInflater().inflate(R.layout.progress, null);
		((TextView) view.findViewById(R.id.progress_tv)).setText(R.string.logining);
		loginDialog = MyDialog.create(R.string.tip, view, R.string.cancel);//应该每次重新new
		
		loginThread = new Thread(new Runnable() {
			public void run() {
				OnlineMgr.sendCmd(CmdVO.LOGIN, J.toJson(vo), Login.this);
			}
		});
		loginThread.start();
	}
	
	private Map<String, Object> getMap(Player p) {
		Map<String, Object> map = null;
		if(p!=null) {
			map = new HashMap<String, Object>();
			map.put(Player.NAME, p.name);
			map.put(Player.SCORE, p.score);
			map.put(Player.TITLE, PlayerMgr.findTitle(p.score));
		}
		return map;
	}

	public void onItemClick(AdapterView<?> parent, View view, int position,
			long id) {
		if(vos==null) return;
		initLoginInfo(vos.get(position), true);  
	}
	
	/**初始化登陆框**/
	private void initLoginInfo(Player v, boolean click) {//这些if的排列顺序不能变
		if(v==null) return;
		if(!click) accountET.setText(v.account); //click的不能设置，不然dropDown又会弹出来
		if(v.rememberPwd!=null && v.rememberPwd) { //如果记住密码
			pwdET.setText(v.pwd);
			rememberPwd.setChecked(true);
		}
		if(v.autoLogin==null || !v.autoLogin) {//如果不是自动登陆
			autoLogin.setChecked(false);
		}
		if(v.autoLogin!=null && v.autoLogin) {//如果自动登陆(会影响到"记住密码")
			pwdET.setText(v.pwd);
			rememberPwd.setChecked(true);
			autoLogin.setChecked(true);
		}
		if(v.rememberPwd==null || !v.rememberPwd) { //如果不是记住密码(会影响到"自动登陆")
			pwdET.setText(null);
			rememberPwd.setChecked(false);
			autoLogin.setChecked(false);
		}
	}

	public void onDismiss(DialogInterface dialog) {
		super.onDismiss(dialog);
		if(dialog==MyDialog.getDialog(loginDialog)) {
			if(MyDialog.getBtn(loginDialog, R.string.cancel)!=null) {//正在登陆的弹出框 
				//杀掉登陆线程
				killThread(loginThread);
			}
		} else if(dialog==MyDialog.getDialog(delAccountDialog)) {
			selectedAccounts.clear();
		}
	}
	
	private void openDelAccountsDialog(List<Player> playerList){
		data = new ArrayList<Map<Object,Object>>();
		if(playerList != null) {
			for (Player p : playerList) {
				Map<Object, Object> map = new HashMap<Object, Object>();
				map.put(Player.ACCOUNT, p.account);
				map.put("check", false);
				data.add(map);
			}
		} else {
			data = null;
		}
		
		adapter = new MyAdapter(this, data, 
				R.layout.del_account_item, 
				new String[]{Player.ACCOUNT, "check"}, 
				new int[]{R.id.account, R.id.check}, 
				this);
		
		if(delAccountDialog==null) {
			View v = LayoutInflater.from(getApplicationContext()).inflate(R.layout.del_account, null);
			delAccount = (Button) v.findViewById(R.id.delete_account);
			convert = (Button) v.findViewById(R.id.convert);
			cancelDel = (Button) v.findViewById(R.id.cancel_del);
			delAccount.setOnClickListener(this);
			convert.setOnClickListener(this);
			cancelDel.setOnClickListener(this);
			listView  = (ListView) v.findViewById(R.id.account_list);
			listView.setAdapter(adapter);
			delAccountDialog = MyDialog.create(R.string.del_account_tip, v, null, null);
		} else {
			listView.setAdapter(adapter);
			if(!delAccountDialog.dialog.isShowing()) delAccountDialog.dialog.show();
		}
	}
	
	/**处理删除帐号界面的组件**/
	public void dealViews(Map<Integer, View> holder, int position) {
		CheckBox box = (CheckBox) holder.get(R.id.check);
		TextView tv = (TextView) holder.get(R.id.account);
		box.setOnCheckedChangeListener(Login.this);
		String txt = tv.getText().toString();
		box.setChecked(selectedAccounts.contains(txt));
	}
	
	/**打开排行榜**/
	private void openRank() {
		View v = LayoutInflater.from(getApplicationContext()).inflate(R.layout.progress, null);
		TextView tv = (TextView) v.findViewById(R.id.progress_tv);
		tv.setText(R.string.rank_loading);
		rankDialog = MyDialog.create(R.string.rank, v, R.string.close);
	}
}
