package rt.lanyo.game.ddz.mgr;

import java.util.ArrayList;
import java.util.List;

import rt.lanyo.game.ddz.R;
import rt.lanyo.game.ddz.model.Btn;
import rt.lanyo.game.ddz.util.G;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Paint;
/**
 * 管理操作按钮:叫分按钮、出牌按钮等
 */
public class BtnMgr {
	public static List<Btn> btns;
	public static Btn score1Btn;
	public static Btn score2Btn;
	public static Btn score3Btn;
	public static Btn bjBtn;
	public static Btn tipBtn;
	public static Btn bcBtn;
	public static Btn cpBtn;
	public static Btn qxBtn;
	public static Btn settingBtn;
	public static Btn taskBtn;
	public static int beginBtnX;// 按钮显示的x位置
	public static int beginBtnY;// 按钮显示的y位置
	public static int btnWidth;
	public static int btnHeight;
	private static final byte SCORE_BTN_NUM = 4;//叫分按钮个数
	private static final byte HANDLE_BTN_NUM = 4;//叫分按钮个数
	
	public static void loadBtns() {
		if(btns!=null) return;
		btns=new ArrayList<Btn>();
		score1Btn=loadScoreBtn(R.drawable.btn_01, 0);
		score2Btn=loadScoreBtn(R.drawable.btn_02, 1);
		score3Btn=loadScoreBtn(R.drawable.btn_03, 2);
		bjBtn=loadScoreBtn(R.drawable.btn_bj, 3);
		
		cpBtn=loadHandleBtn(R.drawable.btn_cp, 0);
		bcBtn=loadHandleBtn(R.drawable.btn_bc, 1);
		tipBtn=loadHandleBtn(R.drawable.btn_tip, 2);
		qxBtn=loadHandleBtn(R.drawable.btn_qx, 3);
		
		int x = G.winWidth/2 + ImgMgr.miniCardWidth*2;
		int y = 10;
		settingBtn = loadOtherBtn(R.drawable.btn_setting, x, y);
		x += settingBtn.getImg().getWidth() + ImgMgr.miniCardWidth/2;
		taskBtn = loadOtherBtn(R.drawable.btn_help, x, y);
		
		if(G.netMode) {
			settingBtn.show = true;
		}
	}
	
	public static void resetScoreBtns() {
		score1Btn.reset();
		score2Btn.reset();
		score3Btn.reset();
		bjBtn.reset();
	}
	
	public static void showScoreBtns(int score) {
		score1Btn.show=score<1;
		score2Btn.show=score<2;
		score3Btn.show=score<3;
		bjBtn.show=true;
	}
	
	public static void initBtns() {
		resetScoreBtns();
		resetHandleBtns();
		settingBtn.show = true;
		if(G.gameMode != G.GAME_MODE_TASK) {
			taskBtn.reset();
		} else {
			taskBtn.show = true;
		}
	}
	
	public static void showHandleBtns() {
		qxBtn.show=true;
		cpBtn.show=true;
		tipBtn.show=true;
		bcBtn.show=true;
	}
	
	public static void resetHandleBtns() {
		cpBtn.reset();
		tipBtn.reset();
		bcBtn.reset();
		qxBtn.reset();
	}
	
	public static void drawSpecialBtns(Canvas canvas, Paint paint) {
		settingBtn.draw(canvas, paint);
	}
	
	public static void drawNormalBtns(Canvas canvas, Paint paint) {
		for(Btn ub:btns){
			if(ub!=settingBtn)
			ub.draw(canvas, paint);
		}
	}
	
	public static Btn findBtn(float x,float y){
		for(Btn ub:btns){
			if(ub.isClick(x, y)){
				return ub;
			}
		}
		return null;
	}
	
	private static Btn loadBtn(int id, int position, int length) {
		int w = btnWidth+10;
		beginBtnX = G.winWidth - length*w - G.cardMargin;
		beginBtnY = G.winHeight - ImgMgr.cardHeight - btnHeight - 15;
		Bitmap map = ImgMgr.getBitmap(id, btnWidth*2, btnHeight);
		Bitmap img1 = Bitmap.createBitmap(map, 0, 0, btnWidth, btnHeight);
		Bitmap img2= Bitmap.createBitmap(map, btnWidth, 0, btnWidth, btnHeight);
		Btn btn = new Btn(img1, img2, beginBtnX+w*position,beginBtnY, btnWidth, btnHeight);
		btns.add(btn);
		return btn;
	}
	
	private static Btn loadOtherBtn(int id, int x, int y) {
		Bitmap map = BitmapFactory.decodeResource(G.context.getResources(), id);
		int w = map.getWidth()/2;
		int h = map.getHeight();
		Bitmap img1 = Bitmap.createBitmap(map, 0, 0, w, h);
		Bitmap img2= Bitmap.createBitmap(map, w, 0, w, h);
		Btn btn = new Btn(img1, img2, x, y, w, h);
		btns.add(btn);
		return btn;
	}
	
	private static Btn loadScoreBtn(int id, int position) {
		return loadBtn(id, position, SCORE_BTN_NUM);
	}
	
	private static Btn loadHandleBtn(int id, int position) {
		return loadBtn(id, position, HANDLE_BTN_NUM);
	}
}
