package rt.lanyo.game.ddz.model;

import rt.lanyo.game.ddz.mgr.ImgMgr;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Paint;
/**
 * 专门用来播放动画
 */
public class Anim {
	/** 上一帧播放时间 **/  
    private long lastTime = 0;  
    /** 当前帧的ID **/  
    private byte id = 0;  
    /** 帧的总数 **/  
    private byte length = 0;  
    /** 帧的资源图片 **/  
    private Bitmap[] maps = null;  
    /** 是否循环播放 **/  
    private boolean loop = false;  
    /** 播放结束 **/  
    public boolean end = false;  
    /** 动画播放间隙时间 **/  
    private int step = 100;  
      
    public Anim(int [] ids, boolean loop, int step) {
    	this.loop = loop;
    	this.step = step;
	    length = (byte)ids.length;  
	    maps = new Bitmap[length];  
	    for(int i =0; i < length; i++) {  
	        maps[i] = ImgMgr.decodeBitmap(ids[i]);  
	    }  
    }  
      
    public Anim(Bitmap [] maps, boolean loop, int step) {  
	    this.maps = maps;  
	    this.loop = loop;
	    this.step = step;
	    length = (byte)maps.length;
    } 
    
    public Anim(Bitmap map, boolean loop, int step) {
    	this(new Bitmap[]{map}, loop, step);
    }
    
    public Anim(int id, boolean loop, int step) {  
    	this(new int[]{id}, loop, step);
    }
      
    public void drawAnimation(Canvas Canvas, Paint paint, int x, int y) {
    	if(end) {//如果退出,就全部清零
    		id = 0;
    		lastTime=0;
    		return;
    	}
    	
    	if(lastTime==0) {//说明是第一次画
    		lastTime = System.currentTimeMillis();
    	}
        Canvas.drawBitmap(maps[id], x, y, paint);
        long time = System.currentTimeMillis();  
        if (time - lastTime > step) {  
	        lastTime = time;  
	        if (++id >= length) {  
	        	id = 0; //数组下标越界就清零
		        end = !loop;
	        }  
        }
    }  
}
