package rt.lanyo.game.ddz.util;

import java.util.Map;

import rt.lanyo.game.ddz.R;
import rt.lanyo.game.ddz.model.Player;
import rt.lanyo.game.ddz.service.MusicService;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.Typeface;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;
/**
 * 一些游戏公共常量、变量
 */
public class G {
	public static int winWidth;
	public static int winHeight;
	public static Context context;
	public static Player me;
	public static Player curPlayer;
	public static Player lastPlayer;
	public static Map<Object, Activity> activityMap;
	public static boolean isWin;
	public static boolean netMode=false;//是否为网络模式
	/**字体**/
	public static Typeface normalType;
	public static Typeface numType;
	/**字体大小**/
	public static int normalSize = 15; //游戏中一般字体显示大小,默认15
	public static int msgSize = 20;//游戏中消息字体显示大小,默认20
	/**字体颜色**/
	public static final int ME_COLOR = Color.BLACK; //自己的文字颜色
	public static final int OTHER_COLOR = Color.BLACK; //对方的文字颜色
	public static final int BOTTOM_COLOR = Color.BLACK; //底分、翻倍的文字颜色
	public static int msgColor = Color.BLACK; //消息的文字颜色
	public static int numColor = Color.WHITE; //数字的颜色
	/**画牌相关**/
	public static int cardStep = 20;  //用户手中牌的相邻宽度,默认20
	public static int cardMargin = 20;//显示用户手中牌的左右预留空间,默认20
	public static final byte MSG_MARGIN = 10;//消息文字与消息框的间距
	/**状态**/
	public static final byte STATUS_EXIT = -1;//要退出游戏
	public static final byte STATUS_WELCOME = 0;//欢迎界面
	public static final byte STATUS_LOGIN = 1;//登录界面
	public static final byte STATUS_REGISTER = 2;//注册界面
	public static final byte STATUS_ROOM=3;//ROOM界面
	public static final byte STATUS_LOADING=4;//网络加载中
	public static final byte STATUS_ENTER = 5;//刚进入游戏界面,未叫分
	public static final byte STATUS_BEGIN = 6;//叫分了,可以出牌 
	public static final byte STATUS_EXCITING = 7;//兴奋状态
	public static final byte STATUS_END = 8;//游戏结束，已经分胜负
	public static final byte STATUS_INFO = 9;//角色界面 
	public static final byte STATUS_TASK = 10;//闯关界面
	public static byte status = STATUS_WELCOME;
	
	
	/**模式**/
	public static byte gameMode = 0;//游戏模式：0为普通模式，1为娱乐模式,2为闯关模式
	public static final byte GAME_MODE_NORMAL = 0;
	public static final byte GAME_MODE_FUN = 1;
	public static final byte GAME_MODE_TASK = 2;
	/**翻倍**/
	public static final byte NORMAL_MULTIPLE = 2;
	public static final byte FUN_MULTIPLE = 8;
	public static final byte MULTIPLE_BIT = 4;  //倍数最多显示多少位数
	public static byte multiple = NORMAL_MULTIPLE; //炸弹翻几倍,默认是2倍
	/**时间常量**/
	public static final int WELCOME_TIME = 500;//欢迎界面持续时间
	public static final int BTN_DELAY_TIME = 200;//按钮反应时间
	public static final int PLAYER_STEP_TIME = 500;//玩家之间出牌间隔时间
	public static final int SPECIAL_ANIM_TIME = 1500;//特殊出牌动画的延长时间,比如飞机、炸弹
	public static final int SHOW_END_CARDS_TIME = 500; //结束500毫秒后亮出所有玩家的牌
	public static final int SHOW_SCORE_BOARD_TIME = 500;  //亮出玩家牌500毫秒后弹出计分板
	public static final int LEVEL_UP_TIME = 3000; //升级图片停留时间
	public static final int MSG_TIME = 1000; //一般消息的显示时间
	public static final byte GAME_WAIT_TIME = 15;//10S后对方会催你出牌
	public static final byte CLOCK_STAY_TIME = 30;  //时钟停留时间:20S
	/**设置常量**/
	public static final byte MAX_CARD_NUMS = 7; //对方每行最多显示多少牌
	public static final float MAX_BRIGHTNESS = 1.0f; //游戏屏幕最高亮度
	public static final float MIN_BRIGHTNESS = 0.01f; //游戏屏幕最低亮度
	public static final float INIT_BRIGHTNESS = 0.5f; //游戏屏幕默认亮度
	
	public static void exit() {
		activityMap.clear();
		startMusicService(MusicService.CMD_STOP);
		closeMusicService();
		G.status = G.STATUS_EXIT;
		System.gc();
	}

	public static void startMusicService(byte cmd) {
		Intent intent = new Intent();
		intent.putExtra(MusicService.CMD, cmd);
		intent.setClass(context, MusicService.class);
		context.startService(intent);
	}
	
	public static void startMusicService(int index, byte cmd) {
		Intent intent = new Intent();
		intent.putExtra(MusicService.MUSIC, index);
		intent.putExtra(MusicService.CMD, cmd);
		intent.setClass(context, MusicService.class);
		context.startService(intent);
	}
	
	public static void closeMusicService() {
		Intent intent = new Intent();
		intent.setClass(context, MusicService.class);
		context.stopService(intent);
	}
	
	public static void sleep(long time) {
		try {
			Thread.sleep(time);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
	
	public static void run(Runnable r) {
		new Thread(r).start();
	}
	
	public static void destroyThread(Thread thread) {
		if(thread!=null && thread.isAlive()) {
			boolean retry = true;
			while(retry) {
				try {
					thread.join();
					thread = null;
					retry = false;
				} catch(Exception e) {
					e.printStackTrace();
				}
			}
	    }
	}
	
	public static void toast(int id) {
		toast(context.getString(id));
	}
	
	public static void toast(String t) {
        View layout = LayoutInflater.from(context).inflate(R.layout.toast, null);
        TextView text = (TextView) layout.findViewById(R.id.toast);
        text.setText(t);
        Toast toast = new Toast(context);
        toast.setGravity(Gravity.CENTER_VERTICAL, 0, 0);
        toast.setDuration(Toast.LENGTH_SHORT);
        toast.setView(layout);
        toast.show();
	}
}
