package rt.lanyo.game.ddz.widget;

import java.util.List;
import java.util.Map;

import rt.lanyo.game.ddz.Info;
import rt.lanyo.game.ddz.R;
import rt.lanyo.game.ddz.Room;
import rt.lanyo.game.ddz.adapter.MyAdapter;
import rt.lanyo.game.ddz.adapter.MyAdapter.ViewCallback;
import rt.lanyo.game.ddz.util.U;
import rt.lanyo.game.ddz.vo.DeskVO;
import android.content.Context;
import android.graphics.Color;
import android.util.AttributeSet;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.GridView;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

public class DeskGrid extends GridView implements ViewCallback{
	public MyAdapter adapter;
	public List<DeskVO> vos;
	private Context context;
	
	public DeskGrid(Context context, AttributeSet attrs) {
		super(context, attrs);
		setNumColumns(2);
		setCacheColorHint(Color.parseColor("#00000000"));
		setStretchMode(STRETCH_COLUMN_WIDTH);
		setGravity(Gravity.CENTER);
		setHorizontalSpacing(U.dip2px(context, 10));
		setVerticalSpacing(U.dip2px(context, 10));
		setColumnWidth(U.dip2px(context, 220));
	}

	public void setAdapter(final Context context) {
		this.context = context;
		if(adapter==null) {
			adapter = new MyAdapter(context, R.layout.room_item,
					new int[]{R.id.desk_num, R.id.seat1, R.id.seat2, R.id.seat3, R.id.desk,
					R.id.ready1, R.id.ready2,R.id.ready3}, 
					this, vos.size());
			super.setAdapter(adapter);
		} else {
			adapter.notifyDataSetChanged();
		}
	}
	
	private void setSeatStatus(Integer index, Button seat) {
		if(index>=0) {
			seat.setBackgroundResource(Info.images[index]);
		} else {
			seat.setBackgroundResource(R.drawable.seat_empty);
		}
	}

	public void dealViews(Map<Integer, View> holder, int position) {
		TextView num = (TextView) holder.get(R.id.desk_num);
		Button seat1 = (Button) holder.get(R.id.seat1);
		Button seat2 = (Button) holder.get(R.id.seat2);
		Button seat3 = (Button) holder.get(R.id.seat3);
		RelativeLayout desk = (RelativeLayout) holder.get(R.id.desk);
		ImageView ready1 = (ImageView) holder.get(R.id.ready1);
		ImageView ready2 = (ImageView) holder.get(R.id.ready2);
		ImageView ready3 = (ImageView) holder.get(R.id.ready3);
		
		if(context instanceof Room) {
			Room room = (Room) context;
			seat1.setOnClickListener(room);
			seat2.setOnClickListener(room);
			seat3.setOnClickListener(room);
		}
		
		if(vos==null || vos.isEmpty()) return;
		
		DeskVO vo = vos.get(position);
		num.setText(vo.id.toString());
		ready1.setVisibility(vo.leftReady?ImageView.VISIBLE:ImageView.GONE);
		ready2.setVisibility(vo.rightReady?ImageView.VISIBLE:ImageView.GONE);
		ready3.setVisibility(vo.bottomReady?ImageView.VISIBLE:ImageView.GONE);
		desk.setBackgroundResource(vo.begining?R.drawable.desk2:R.drawable.desk);
		setSeatStatus(vo.left, seat1);
		setSeatStatus(vo.right, seat2);
		setSeatStatus(vo.bottom, seat3);
	}
}
