package rt.lanyo.game.ddz.mgr;

import android.content.Context;
import android.content.SharedPreferences;
/**
 * 存储游戏设置:音乐、音效、震动
 */
public class SaveMgr {
  public static final String SOUND = "sound";
  public static final String MUSIC = "music";
  public static final String VIBRATE = "vibrate";
  public static final String ANIM = "anim";
  public static final String BRIGHTNESS = "brightness";
  public static final String BEST_RECORD = "bestRecord";
	
  public SharedPreferences.Editor editor;
  public SharedPreferences data;
  public final String FILE_NAME = "ddz";
  
  public SaveMgr(Context context) {
	  data = context.getSharedPreferences(FILE_NAME, Context.MODE_PRIVATE);
	  editor = data.edit();
  }
  
  public float get(String str, float paramFloat) {
    return data.getFloat(str, paramFloat);
  }

  public int get(String str, int paramInt) {
    return data.getInt(str, paramInt);
  }
  
  public boolean get(String str, boolean paramBol) {
	    return data.getBoolean(str, paramBol);
  }

  public String get(String str1, String str2) {
    return data.getString(str1, str2);
  }

  public void update(String str, float paramFloat) {
    editor.putFloat(str, paramFloat);
  }

  public void update(String str, int paramInt) {
    editor.putInt(str, paramInt);
  }

  public void update(String str1, String str2) {
    editor.putString(str1, str2);
  }
  
  public void update(String str1, boolean paramBol) {
	editor.putBoolean(str1, paramBol);
  }

  public void commit() {
    editor.commit();
  }
}
